--Example of a GameState file

--Table
GameState = {}

--New
function GameState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function GameState:load()
end

--Close
function GameState:close()
end

--Enable
function GameState:enable()
end

--Disable
function GameState:disable()
end

--Update
function GameState:update(dt)
	xcloud = xcloud + 80 * dt
		
	if xcloud >= 2592 + 192 then
		xcloud = 0 - 192
	end
			
	dt = math.min(dt, 0.07)
	frame = dt * 30
	
	if guy.y < 32 then --Shove him back!!!!!
		guy.y = 32
	end
    if guy.y > map.height * 32 + 32 then
		guy.y = map.height * 32 + 32
	end
	if guy.x < 1 then
		guy.x = 1
	end
	if guy.x > map.width * 32 then
		guy.x = map.width * 32 --This must be more than his speed forward
	end
		
	if (mapCollide(guy.x + 12, guy.y) == 9 or mapCollide(guy.x + 12, guy.y) == 10) and love.keyboard.isDown("w") then
		guy.grav = 0
		guy.ySpeed = -10
	else
		guy.grav = 1.5
	end
		
		
	if guy.direction == 0 then
		ani_guy_r:update(dt)
	elseif guy.direction == 1 then
		ani_guy_l:update(dt)
	end
		
	guy.ySpeed = guy.ySpeed + guy.grav * frame
	guy.y = guy.y + guy.ySpeed * frame
	boundingChecks(guy, map)
		
	--AI for NPCs
	for i,v in ipairs(NCP) do
		v.ySpeed = v.ySpeed + v.grav * frame
		v.y = v.y + v.ySpeed * frame
		NCPboundingChecks(2, v, map)
		
		if v.x > guy.x and v.x < guy.x + 150 and v.x > guy.x + 40 then
			if v.y > guy.y + 10 and v.ySpeed == 0 then
				v.ySpeed = -12
			end
			NCPboundingChecks(1, v, map)
			
		elseif v.x < guy.x and v.x > guy.x - 150 and v.x < guy.x - 40 then
		
			if v.y > guy.y + 10 and v.ySpeed == 0 then
				v.ySpeed = -12
			end
			NCPboundingChecks(0, v, map)
		end
	end
	
	camera:setPosition(guy.x - width / 2, guy.y - height / 2)
end

--Draw
function GameState:draw()
	camera:set()
		
	love.graphics.setColor(40,109,214)
	love.graphics.rectangle('fill',0,0,32 * map.width + 32, 32 * 23)--sky
	love.graphics.setColor(255,255,255)
	
	love.graphics.setColor(39,22,10)
	love.graphics.rectangle('fill',0,21 * 32, 32 * map.width + 32, 32 * 68)--ground
	love.graphics.setColor(255,255,255)
		
	love.graphics.draw(cloud, xcloud - 192, 32)
	
	-- Rendering Magic
	local y_temp =  math.floor(camera:RePositionY(0)/map.tiles.height)
	local y2_temp = ( camera:RePositionY( love.graphics.getHeight() ) / map.tiles.height ) + 1
	local x_temp = math.floor(camera:RePositionX(0)/map.tiles.width)
	local x2_temp = ( camera:RePositionX( love.graphics.getWidth() ) / map.tiles.width ) + 1
		
	if y2_temp > map.height then
		y2_temp = map.height
	end
	
	if x2_temp > map.width then
		x2_temp = map.width
	end
		
	for y = y_temp , y2_temp do
		for x = x_temp , x2_temp do
			if map[y][x] == 2 then
				if map[y-1][x] > 1 then
					map[y][x] = 4
				end
				love.graphics.draw(grass, x * 32, y * 32)
			end
			if map[y][x] == 3 then
				love.graphics.draw(stone, x * 32, y * 32)
			end
			if map[y][x] == 4 then
				if map[y-1][x] == 1 and (map[y][x+1] == 2 or map[y][x-1] == 2) then
					map[y][x] = 2
				end
				love.graphics.draw(dirt, x * 32, y * 32)
			end
			if map[y][x] == 1 then
			end
			if map[y][x] == 5 then
				love.graphics.draw(wood, x * 32, y * 32)
			end
			if map[y][x] == 6 then
				love.graphics.draw(plank, x * 32, y * 32)
			end
			if map[y][x] == 7 then
				love.graphics.draw(glass, x * 32, y * 32)
			end
			if map[y][x] == 8 then
				love.graphics.draw(leaf, x * 32, y * 32)
			end
			if map[y][x] == 9 then
				love.graphics.draw(ladder, x * 32, y * 32)
			end
			if map[y][x] == 10 then
				love.graphics.draw(water, x * 32, y * 32)
				
				if map[y+1][x] > 1 and ( map[y+1][x] < 10 or map[y+1][x] == 11 ) and map[y][x+1] == 1 then
					map[y][x+1] = 10
				end
				if map[y+1][x] > 1 and ( map[y+1][x] < 10 or map[y+1][x] == 11 ) and map[y][x-1] == 1 then
					map[y][x-1] = 10
				end
				if map[y+1][x] == 1 then
					map[y+1][x] = 10
				end
			end
			if map[y][x] == 11 then
				love.graphics.draw(sand, x * 32, y * 32)
				
				if map[y+1][x] == 1 or map[y+1][x] == 10 then
					map[y+1][x] = 11
					map[y][x] = 1
				end
			end
		end
	end
	
	if guy.direction == 0 then
		ani_guy_r:draw(guy_pic, guy.x, guy.y)
	elseif guy.direction == 1 then
		ani_guy_l:draw(guy_pic_l, guy.x, guy.y)
	end
		
	for i,v in ipairs(NCP) do
		if v.direction == 0 then
			love.graphics.draw(v.pic_r, v.x, v.y)
			love.graphics.print(v.name, v.x, v.y - 18)
		elseif v.direction == 1 then
			love.graphics.draw(v.pic_l, v.x, v.y)
			love.graphics.print(v.name, v.x, v.y - 18)
		end
	end
		
	camera:unset()
	love.graphics.print("FPS:"..love.timer.getFPS().."\nX:"..guy.x.."\nY:"..guy.y, 0, 0)
		
	for i = 1, numBlocks - 1 do
		love.graphics.draw(menu, 160 + i * 32, 0)
		if i == guy.selected then
			love.graphics.draw(sel_menu, 160 + i * 32, 0)
		end
		love.graphics.draw( tiles[i] , 160 + i * 32 + 1, 0 + 1)
	end
end

--KeyPressed
function GameState:keypressed(key, unicode)
	if key == "w" and guy.ySpeed == 0 then
		guy.ySpeed = -12
	end
end

--KeyReleased
function GameState:keyreleased(key, unicode)
end

--MousePressed
function GameState:mousepressed(x, y, button)
	x = camera:RePositionX(x)
	y = camera:RePositionY(y)
	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)

	if button == 'l' and y > 32 and ( mapCollide(x, y) < 2 or mapCollide(x, y) == 10 )and ( map[mapX+1][mapY] > 1 or map[mapX-1][mapY] > 1 or map[mapX][mapY+1] > 1 or map[mapX][mapY-1] > 1 ) then
		map[mapX][mapY] = map.tiles.current
	end
	if button == 'r' and y > 32 then
		map[mapX][mapY] = 1
	end

	-- Scrolling Feature
	if button == "wu" then
		guy.selected = guy.selected % numBlocks + 1
		map.tiles.current = map.tiles.current % numBlocks + 1
	elseif button == "wd" then
		guy.selected = (guy.selected - 2) % numBlocks + 1
		map.tiles.current = (map.tiles.current - 2) % numBlocks + 1
	end
end

--MouseReleased
function GameState:mousereleased(x, y, button)
end