--Example of a GameState file

--Table
IntroState = {}

--New
function IntroState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function IntroState:load()
	love.graphics.setDefaultImageFilter("nearest","nearest")

	grass = love.graphics.newImage("textures/grass.png") --2
	stone = love.graphics.newImage("textures/stone.png") --3
	dirt = love.graphics.newImage("textures/dirt.png") --4
	grid = love.graphics.newImage("textures/grid.png") --1
	guy_pic = love.graphics.newImage("textures/player_r.png")
	guy_pic_l = love.graphics.newImage("textures/player_l.png")
	menu = love.graphics.newImage("textures/selected.png")
	sel_menu = love.graphics.newImage("textures/sel_menu.png")
	wood = love.graphics.newImage("textures/wood.png") --5
	plank = love.graphics.newImage("textures/plank.png") --6
	glass = love.graphics.newImage("textures/glass.png") --7
	leaf = love.graphics.newImage("textures/leaves.png") --8
	ladder = love.graphics.newImage("textures/ladder.png") --9
	water = love.graphics.newImage("textures/water.png") --10
	sand = love.graphics.newImage("textures/sand.png") --11
	cloud = love.graphics.newImage("textures/cloud.png")--CLOUD
	introscreen = love.graphics.newImage("textures/intro.png")--intro screen
	emblem = love.graphics.newImage("textures/emblem.png")--intro screen
	icon = love.graphics.newImage("textures/icon.png") -- Icon
	
	love.graphics.setIcon(icon)
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()

	guy = { --The table for the player
		x = 32,
		y = 32 * 8,
		ySpeed = 0,
		grav = 1.5,
		width = 30,
		height = 30,
		direction = 0,
		selected = 1,
	}
		
	NCP = {}
		
	tiles = {}
	tiles[1] = grass
	tiles[2] = stone
	tiles[3] = dirt
	tiles[4] = wood
	tiles[5] = plank
	tiles[6] = glass
	tiles[7] = leaf
	tiles[8] = ladder
	tiles[9] = water
	tiles[10] = sand
	
	map = {}
	map.tiles = {}
	map.tiles.width, map.tiles.height = 32, 32 --Tiles width and height
	map.tiles.current = 2 -- This is the currently selected tile, the one you put when you click
	map.width = size_of_map_width
	map.height = size_of_map_height
   
    for x = 0, map.height do
		map[x] = {}
		for y = 0, map.width do
			if x < 20 then
				map[x][y] = 1
			
			elseif x < 21 then
				map[x][y] = math.random(1,2)
				
			elseif x < 23 then
				map[x][y] = 2
				GenerateTree(map,x,y)
				GenerateMegaTree(map,x,y)
				GenerateNCP(map,x,y,math.random(1,3),NCP)
				
			else
				map[x][y] = math.random(3,4)
				
			end
	
		if map[x][y] == 4 and map[x-1][y] == 1 and x < 15 then
			map[x][y] = 2
		end
		 
		 --The Great Caves Generation
		if x > 40 and x < 70 and math.random(5) == 1 then
			map[x][y] = 1
			map[x-1][y] = 1
			map[x-2][y+1] = 1
			map[x][y-1] = 1
		end
		 
		end
	end
   
	local grid_l = anim8.newGrid(30, 30, guy_pic_l:getWidth(), guy_pic_l:getHeight())
	local grid_r = anim8.newGrid(30, 30, guy_pic:getWidth(), guy_pic:getHeight())
   
	ani_guy_l = anim8.newAnimation('loop', grid_l('1-7,1'), 0.1)
	ani_guy_r = anim8.newAnimation('loop', grid_r('1-7,1'), 0.1)
   
	xcloud = 0
	numBlocks = 11
	introd = 0
   
	camera:setBounds(0, 0, (map.width * map.tiles.width) - width, (map.height * map.tiles.height) - height)
end

--Close
function IntroState:close()
end

--Enable
function IntroState:enable()
end

--Disable
function IntroState:disable()
end

--Update
function IntroState:update(dt)
	introd = introd + 1 * dt
	if introd >= 2 then
		enableState("menu")
		disableState("intro")
	end
end

--Draw
function IntroState:draw()
	love.graphics.draw( introscreen, 0, 0 )
	love.graphics.draw( emblem, 670 / 2 - 16, 180 )
end

--KeyPressed
function IntroState:keypressed(key, unicode)
end

--KeyRelease
function IntroState:keyrelease(key, unicode)
end

--MousePressed
function IntroState:mousepressed(x, y, button)
end

--MouseReleased
function IntroState:mousereleased(x, y, button)
end

